Code

Merge branch 'jn/maint-doc-user-manual-html-doctype'
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
83 unset GREP_OPTIONS
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86         1|2|true)
87                 echo "* warning: Some tests will not work if GIT_TRACE" \
88                         "is set as to trace on STDERR ! *"
89                 echo "* warning: Please set GIT_TRACE to something" \
90                         "other than 1, 2 or true ! *"
91                 ;;
92 esac
94 # Convenience
95 #
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
100 # Each test should start with something like this, after copyright notices:
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
104 # '
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107                 TERM=$ORIGINAL_TERM &&
108                 export TERM &&
109                 [ -t 1 ] &&
110                 tput bold >/dev/null 2>&1 &&
111                 tput setaf 1 >/dev/null 2>&1 &&
112                 tput sgr0 >/dev/null 2>&1
113         ) &&
114         color=t
116 while test "$#" -ne 0
117 do
118         case "$1" in
119         -d|--d|--de|--deb|--debu|--debug)
120                 debug=t; shift ;;
121         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122                 immediate=t; shift ;;
123         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125         -h|--h|--he|--hel|--help)
126                 help=t; shift ;;
127         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128                 verbose=t; shift ;;
129         -q|--q|--qu|--qui|--quie|--quiet)
130                 # Ignore --quiet under a TAP::Harness. Saying how many tests
131                 # passed without the ok/not ok details is always an error.
132                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
133         --with-dashes)
134                 with_dashes=t; shift ;;
135         --no-color)
136                 color=; shift ;;
137         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138                 valgrind=t; verbose=t; shift ;;
139         --tee)
140                 shift ;; # was handled already
141         --root=*)
142                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143                 shift ;;
144         *)
145                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
146         esac
147 done
149 if test -n "$color"; then
150         say_color () {
151                 (
152                 TERM=$ORIGINAL_TERM
153                 export TERM
154                 case "$1" in
155                         error) tput bold; tput setaf 1;; # bold red
156                         skip)  tput bold; tput setaf 2;; # bold green
157                         pass)  tput setaf 2;;            # green
158                         info)  tput setaf 3;;            # brown
159                         *) test -n "$quiet" && return;;
160                 esac
161                 shift
162                 printf "%s" "$*"
163                 tput sgr0
164                 echo
165                 )
166         }
167 else
168         say_color() {
169                 test -z "$1" && test -n "$quiet" && return
170                 shift
171                 echo "$*"
172         }
173 fi
175 error () {
176         say_color error "error: $*"
177         GIT_EXIT_OK=t
178         exit 1
181 say () {
182         say_color info "$*"
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
188 if test "$help" = "t"
189 then
190         echo "$test_description"
191         exit 0
192 fi
194 exec 5>&1
195 if test "$verbose" = "t"
196 then
197         exec 4>&2 3>&1
198 else
199         exec 4>/dev/null 3>/dev/null
200 fi
202 test_failure=0
203 test_count=0
204 test_fixed=0
205 test_broken=0
206 test_success=0
208 test_external_has_tap=0
210 die () {
211         code=$?
212         if test -n "$GIT_EXIT_OK"
213         then
214                 exit $code
215         else
216                 echo >&5 "FATAL: Unexpected exit with code $code"
217                 exit 1
218         fi
221 GIT_EXIT_OK=
222 trap 'die' EXIT
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
231 # In particular, quoting isn't enough, as the path may contain the same quote
232 # that we're using.
233 test_set_editor () {
234         FAKE_EDITOR="$1"
235         export FAKE_EDITOR
236         EDITOR='"$FAKE_EDITOR"'
237         export EDITOR
240 test_decode_color () {
241         sed     -e 's/.\[1m/<WHITE>/g' \
242                 -e 's/.\[31m/<RED>/g' \
243                 -e 's/.\[32m/<GREEN>/g' \
244                 -e 's/.\[33m/<YELLOW>/g' \
245                 -e 's/.\[34m/<BLUE>/g' \
246                 -e 's/.\[35m/<MAGENTA>/g' \
247                 -e 's/.\[36m/<CYAN>/g' \
248                 -e 's/.\[m/<RESET>/g'
251 q_to_nul () {
252         perl -pe 'y/Q/\000/'
255 q_to_cr () {
256         tr Q '\015'
259 q_to_tab () {
260         tr Q '\011'
263 append_cr () {
264         sed -e 's/$/Q/' | tr Q '\015'
267 remove_cr () {
268         tr '\015' Q | sed -e 's/Q$//'
271 test_tick () {
272         if test -z "${test_tick+set}"
273         then
274                 test_tick=1112911993
275         else
276                 test_tick=$(($test_tick + 60))
277         fi
278         GIT_COMMITTER_DATE="$test_tick -0700"
279         GIT_AUTHOR_DATE="$test_tick -0700"
280         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
283 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
285 # This will commit a file with the given contents and the given commit
286 # message.  It will also add a tag with <message> as name.
288 # Both <file> and <contents> default to <message>.
290 test_commit () {
291         file=${2:-"$1.t"}
292         echo "${3-$1}" > "$file" &&
293         git add "$file" &&
294         test_tick &&
295         git commit -m "$1" &&
296         git tag "$1"
299 # Call test_merge with the arguments "<message> <commit>", where <commit>
300 # can be a tag pointing to the commit-to-merge.
302 test_merge () {
303         test_tick &&
304         git merge -m "$1" "$2" &&
305         git tag "$1"
308 # This function helps systems where core.filemode=false is set.
309 # Use it instead of plain 'chmod +x' to set or unset the executable bit
310 # of a file in the working directory and add it to the index.
312 test_chmod () {
313         chmod "$@" &&
314         git update-index --add "--chmod=$@"
317 # Use test_set_prereq to tell that a particular prerequisite is available.
318 # The prerequisite can later be checked for in two ways:
320 # - Explicitly using test_have_prereq.
322 # - Implicitly by specifying the prerequisite tag in the calls to
323 #   test_expect_{success,failure,code}.
325 # The single parameter is the prerequisite tag (a simple word, in all
326 # capital letters by convention).
328 test_set_prereq () {
329         satisfied="$satisfied$1 "
331 satisfied=" "
333 test_have_prereq () {
334         case $satisfied in
335         *" $1 "*)
336                 : yes, have it ;;
337         *)
338                 ! : nope ;;
339         esac
342 # You are not expected to call test_ok_ and test_failure_ directly, use
343 # the text_expect_* functions instead.
345 test_ok_ () {
346         test_success=$(($test_success + 1))
347         say_color "" "ok $test_count - $@"
350 test_failure_ () {
351         test_failure=$(($test_failure + 1))
352         say_color error "not ok - $test_count $1"
353         shift
354         echo "$@" | sed -e 's/^/#       /'
355         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
358 test_known_broken_ok_ () {
359         test_fixed=$(($test_fixed+1))
360         say_color "" "ok $test_count - $@ # TODO known breakage"
363 test_known_broken_failure_ () {
364         test_broken=$(($test_broken+1))
365         say_color skip "not ok $test_count - $@ # TODO known breakage"
368 test_debug () {
369         test "$debug" = "" || eval "$1"
372 test_run_ () {
373         test_cleanup=:
374         eval >&3 2>&4 "$1"
375         eval_ret=$?
376         eval >&3 2>&4 "$test_cleanup"
377         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
378                 echo ""
379         fi
380         return 0
383 test_skip () {
384         test_count=$(($test_count+1))
385         to_skip=
386         for skp in $GIT_SKIP_TESTS
387         do
388                 case $this_test.$test_count in
389                 $skp)
390                         to_skip=t
391                         break
392                 esac
393         done
394         if test -z "$to_skip" && test -n "$prereq" &&
395            ! test_have_prereq "$prereq"
396         then
397                 to_skip=t
398         fi
399         case "$to_skip" in
400         t)
401                 say_color skip >&3 "skipping test: $@"
402                 say_color skip "ok $test_count # skip $1"
403                 : true
404                 ;;
405         *)
406                 false
407                 ;;
408         esac
411 test_expect_failure () {
412         test "$#" = 3 && { prereq=$1; shift; } || prereq=
413         test "$#" = 2 ||
414         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
415         if ! test_skip "$@"
416         then
417                 say >&3 "checking known breakage: $2"
418                 test_run_ "$2"
419                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
420                 then
421                         test_known_broken_ok_ "$1"
422                 else
423                         test_known_broken_failure_ "$1"
424                 fi
425         fi
426         echo >&3 ""
429 test_expect_success () {
430         test "$#" = 3 && { prereq=$1; shift; } || prereq=
431         test "$#" = 2 ||
432         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
433         if ! test_skip "$@"
434         then
435                 say >&3 "expecting success: $2"
436                 test_run_ "$2"
437                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
438                 then
439                         test_ok_ "$1"
440                 else
441                         test_failure_ "$@"
442                 fi
443         fi
444         echo >&3 ""
447 test_expect_code () {
448         test "$#" = 4 && { prereq=$1; shift; } || prereq=
449         test "$#" = 3 ||
450         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
451         if ! test_skip "$@"
452         then
453                 say >&3 "expecting exit code $1: $3"
454                 test_run_ "$3"
455                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
456                 then
457                         test_ok_ "$2"
458                 else
459                         test_failure_ "$@"
460                 fi
461         fi
462         echo >&3 ""
465 # test_external runs external test scripts that provide continuous
466 # test output about their progress, and succeeds/fails on
467 # zero/non-zero exit code.  It outputs the test output on stdout even
468 # in non-verbose mode, and announces the external script with "# run
469 # <n>: ..." before running it.  When providing relative paths, keep in
470 # mind that all scripts run in "trash directory".
471 # Usage: test_external description command arguments...
472 # Example: test_external 'Perl API' perl ../path/to/test.pl
473 test_external () {
474         test "$#" = 4 && { prereq=$1; shift; } || prereq=
475         test "$#" = 3 ||
476         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
477         descr="$1"
478         shift
479         if ! test_skip "$descr" "$@"
480         then
481                 # Announce the script to reduce confusion about the
482                 # test output that follows.
483                 say_color "" "# run $test_count: $descr ($*)"
484                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
485                 # to be able to use them in script
486                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
487                 # Run command; redirect its stderr to &4 as in
488                 # test_run_, but keep its stdout on our stdout even in
489                 # non-verbose mode.
490                 "$@" 2>&4
491                 if [ "$?" = 0 ]
492                 then
493                         if test $test_external_has_tap -eq 0; then
494                                 test_ok_ "$descr"
495                         else
496                                 say_color "" "# test_external test $descr was ok"
497                                 test_success=$(($test_success + 1))
498                         fi
499                 else
500                         if test $test_external_has_tap -eq 0; then
501                                 test_failure_ "$descr" "$@"
502                         else
503                                 say_color error "# test_external test $descr failed: $@"
504                                 test_failure=$(($test_failure + 1))
505                         fi
506                 fi
507         fi
510 # Like test_external, but in addition tests that the command generated
511 # no output on stderr.
512 test_external_without_stderr () {
513         # The temporary file has no (and must have no) security
514         # implications.
515         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
516         stderr="$tmp/git-external-stderr.$$.tmp"
517         test_external "$@" 4> "$stderr"
518         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
519         descr="no stderr: $1"
520         shift
521         say >&3 "# expecting no stderr from previous command"
522         if [ ! -s "$stderr" ]; then
523                 rm "$stderr"
525                 if test $test_external_has_tap -eq 0; then
526                         test_ok_ "$descr"
527                 else
528                         say_color "" "# test_external_without_stderr test $descr was ok"
529                         test_success=$(($test_success + 1))
530                 fi
531         else
532                 if [ "$verbose" = t ]; then
533                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
534                 else
535                         output=
536                 fi
537                 # rm first in case test_failure exits.
538                 rm "$stderr"
539                 if test $test_external_has_tap -eq 0; then
540                         test_failure_ "$descr" "$@" "$output"
541                 else
542                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
543                         test_failure=$(($test_failure + 1))
544                 fi
545         fi
548 # debugging-friendly alternatives to "test [-f|-d|-e]"
549 # The commands test the existence or non-existence of $1. $2 can be
550 # given to provide a more precise diagnosis.
551 test_path_is_file () {
552         if ! [ -f "$1" ]
553         then
554                 echo "File $1 doesn't exist. $*"
555                 false
556         fi
559 test_path_is_dir () {
560         if ! [ -d "$1" ]
561         then
562                 echo "Directory $1 doesn't exist. $*"
563                 false
564         fi
567 test_path_is_missing () {
568         if [ -e "$1" ]
569         then
570                 echo "Path exists:"
571                 ls -ld "$1"
572                 if [ $# -ge 1 ]; then
573                         echo "$*"
574                 fi
575                 false
576         fi
580 # This is not among top-level (test_expect_success | test_expect_failure)
581 # but is a prefix that can be used in the test script, like:
583 #       test_expect_success 'complain and die' '
584 #           do something &&
585 #           do something else &&
586 #           test_must_fail git checkout ../outerspace
587 #       '
589 # Writing this as "! git checkout ../outerspace" is wrong, because
590 # the failure could be due to a segv.  We want a controlled failure.
592 test_must_fail () {
593         "$@"
594         test $? -gt 0 -a $? -le 129 -o $? -gt 192
597 # Similar to test_must_fail, but tolerates success, too.  This is
598 # meant to be used in contexts like:
600 #       test_expect_success 'some command works without configuration' '
601 #               test_might_fail git config --unset all.configuration &&
602 #               do something
603 #       '
605 # Writing "git config --unset all.configuration || :" would be wrong,
606 # because we want to notice if it fails due to segv.
608 test_might_fail () {
609         "$@"
610         test $? -ge 0 -a $? -le 129 -o $? -gt 192
613 # test_cmp is a helper function to compare actual and expected output.
614 # You can use it like:
616 #       test_expect_success 'foo works' '
617 #               echo expected >expected &&
618 #               foo >actual &&
619 #               test_cmp expected actual
620 #       '
622 # This could be written as either "cmp" or "diff -u", but:
623 # - cmp's output is not nearly as easy to read as diff -u
624 # - not all diff versions understand "-u"
626 test_cmp() {
627         $GIT_TEST_CMP "$@"
630 # This function can be used to schedule some commands to be run
631 # unconditionally at the end of the test to restore sanity:
633 #       test_expect_success 'test core.capslock' '
634 #               git config core.capslock true &&
635 #               test_when_finished "git config --unset core.capslock" &&
636 #               hello world
637 #       '
639 # That would be roughly equivalent to
641 #       test_expect_success 'test core.capslock' '
642 #               git config core.capslock true &&
643 #               hello world
644 #               git config --unset core.capslock
645 #       '
647 # except that the greeting and config --unset must both succeed for
648 # the test to pass.
650 test_when_finished () {
651         test_cleanup="{ $*
652                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
655 # Most tests can use the created repository, but some may need to create more.
656 # Usage: test_create_repo <directory>
657 test_create_repo () {
658         test "$#" = 1 ||
659         error "bug in the test script: not 1 parameter to test-create-repo"
660         owd=`pwd`
661         repo="$1"
662         mkdir -p "$repo"
663         cd "$repo" || error "Cannot setup test environment"
664         "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
665         error "cannot run git init -- have you built things yet?"
666         mv .git/hooks .git/hooks-disabled
667         cd "$owd"
670 test_done () {
671         GIT_EXIT_OK=t
672         test_results_dir="$TEST_DIRECTORY/test-results"
673         mkdir -p "$test_results_dir"
674         test_results_path="$test_results_dir/${0%.sh}-$$.counts"
676         echo "total $test_count" >> $test_results_path
677         echo "success $test_success" >> $test_results_path
678         echo "fixed $test_fixed" >> $test_results_path
679         echo "broken $test_broken" >> $test_results_path
680         echo "failed $test_failure" >> $test_results_path
681         echo "" >> $test_results_path
683         if test "$test_fixed" != 0
684         then
685                 say_color pass "# fixed $test_fixed known breakage(s)"
686         fi
687         if test "$test_broken" != 0
688         then
689                 say_color error "# still have $test_broken known breakage(s)"
690                 msg="remaining $(($test_count-$test_broken)) test(s)"
691         else
692                 msg="$test_count test(s)"
693         fi
694         case "$test_failure" in
695         0)
696                 # Maybe print SKIP message
697                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
699                 if test $test_external_has_tap -eq 0; then
700                         say_color pass "# passed all $msg"
701                         say "1..$test_count$skip_all"
702                 fi
704                 test -d "$remove_trash" &&
705                 cd "$(dirname "$remove_trash")" &&
706                 rm -rf "$(basename "$remove_trash")"
708                 exit 0 ;;
710         *)
711                 if test $test_external_has_tap -eq 0; then
712                         say_color error "# failed $test_failure among $msg"
713                         say "1..$test_count"
714                 fi
716                 exit 1 ;;
718         esac
721 # Test the binaries we have just built.  The tests are kept in
722 # t/ subdirectory and are run in 'trash directory' subdirectory.
723 TEST_DIRECTORY=$(pwd)
724 if test -n "$valgrind"
725 then
726         make_symlink () {
727                 test -h "$2" &&
728                 test "$1" = "$(readlink "$2")" || {
729                         # be super paranoid
730                         if mkdir "$2".lock
731                         then
732                                 rm -f "$2" &&
733                                 ln -s "$1" "$2" &&
734                                 rm -r "$2".lock
735                         else
736                                 while test -d "$2".lock
737                                 do
738                                         say "Waiting for lock on $2."
739                                         sleep 1
740                                 done
741                         fi
742                 }
743         }
745         make_valgrind_symlink () {
746                 # handle only executables
747                 test -x "$1" || return
749                 base=$(basename "$1")
750                 symlink_target=$TEST_DIRECTORY/../$base
751                 # do not override scripts
752                 if test -x "$symlink_target" &&
753                     test ! -d "$symlink_target" &&
754                     test "#!" != "$(head -c 2 < "$symlink_target")"
755                 then
756                         symlink_target=../valgrind.sh
757                 fi
758                 case "$base" in
759                 *.sh|*.perl)
760                         symlink_target=../unprocessed-script
761                 esac
762                 # create the link, or replace it if it is out of date
763                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
764         }
766         # override all git executables in TEST_DIRECTORY/..
767         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
768         mkdir -p "$GIT_VALGRIND"/bin
769         for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
770         do
771                 make_valgrind_symlink $file
772         done
773         OLDIFS=$IFS
774         IFS=:
775         for path in $PATH
776         do
777                 ls "$path"/git-* 2> /dev/null |
778                 while read file
779                 do
780                         make_valgrind_symlink "$file"
781                 done
782         done
783         IFS=$OLDIFS
784         PATH=$GIT_VALGRIND/bin:$PATH
785         GIT_EXEC_PATH=$GIT_VALGRIND/bin
786         export GIT_VALGRIND
787 elif test -n "$GIT_TEST_INSTALLED" ; then
788         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
789         error "Cannot run git from $GIT_TEST_INSTALLED."
790         PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
791         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
792 else # normal case, use ../bin-wrappers only unless $with_dashes:
793         git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
794         if ! test -x "$git_bin_dir/git" ; then
795                 if test -z "$with_dashes" ; then
796                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
797                 fi
798                 with_dashes=t
799         fi
800         PATH="$git_bin_dir:$PATH"
801         GIT_EXEC_PATH=$TEST_DIRECTORY/..
802         if test -n "$with_dashes" ; then
803                 PATH="$TEST_DIRECTORY/..:$PATH"
804         fi
805 fi
806 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
807 unset GIT_CONFIG
808 GIT_CONFIG_NOSYSTEM=1
809 GIT_CONFIG_NOGLOBAL=1
810 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
812 . ../GIT-BUILD-OPTIONS
814 if test -z "$GIT_TEST_CMP"
815 then
816         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
817         then
818                 GIT_TEST_CMP="$DIFF -c"
819         else
820                 GIT_TEST_CMP="$DIFF -u"
821         fi
822 fi
824 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
825 export GITPERLLIB
826 test -d ../templates/blt || {
827         error "You haven't built things yet, have you?"
830 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
831 then
832         GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
833         export GITPYTHONLIB
834         test -d ../git_remote_helpers/build || {
835                 error "You haven't built git_remote_helpers yet, have you?"
836         }
837 fi
839 if ! test -x ../test-chmtime; then
840         echo >&2 'You need to build test-chmtime:'
841         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
842         exit 1
843 fi
845 # Test repository
846 test="trash directory.$(basename "$0" .sh)"
847 test -n "$root" && test="$root/$test"
848 case "$test" in
849 /*) TRASH_DIRECTORY="$test" ;;
850  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
851 esac
852 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
853 rm -fr "$test" || {
854         GIT_EXIT_OK=t
855         echo >&5 "FATAL: Cannot prepare test area"
856         exit 1
859 test_create_repo "$test"
860 # Use -P to resolve symlinks in our working directory so that the cwd
861 # in subprocesses like git equals our $PWD (for pathname comparisons).
862 cd -P "$test" || exit 1
864 this_test=${0##*/}
865 this_test=${this_test%%-*}
866 for skp in $GIT_SKIP_TESTS
867 do
868         case "$this_test" in
869         $skp)
870                 say_color skip >&3 "skipping test $this_test altogether"
871                 skip_all="skip all tests in $this_test"
872                 test_done
873         esac
874 done
876 # Provide an implementation of the 'yes' utility
877 yes () {
878         if test $# = 0
879         then
880                 y=y
881         else
882                 y="$*"
883         fi
885         while echo "$y"
886         do
887                 :
888         done
891 # Fix some commands on Windows
892 case $(uname -s) in
893 *MINGW*)
894         # Windows has its own (incompatible) sort and find
895         sort () {
896                 /usr/bin/sort "$@"
897         }
898         find () {
899                 /usr/bin/find "$@"
900         }
901         sum () {
902                 md5sum "$@"
903         }
904         # git sees Windows-style pwd
905         pwd () {
906                 builtin pwd -W
907         }
908         # no POSIX permissions
909         # backslashes in pathspec are converted to '/'
910         # exec does not inherit the PID
911         ;;
912 *)
913         test_set_prereq POSIXPERM
914         test_set_prereq BSLASHPSPEC
915         test_set_prereq EXECKEEPSPID
916         ;;
917 esac
919 test -z "$NO_PERL" && test_set_prereq PERL
920 test -z "$NO_PYTHON" && test_set_prereq PYTHON
922 # test whether the filesystem supports symbolic links
923 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
924 rm -f y